Page MenuHomePhabricator

Convert TemplateWizard into a beta feature
Closed, ResolvedPublic3 Story Points

Description

Converting TemplateWizard into a beta feature is the best option on the table for rolling it out. We can then push it to all wikis without attempting to get consensus.
In addition to that, it will give the feature discoverability. Otherwise it could be lost amid the myriad other toolbar icons.

For the time being, we should roll it out without a icon popup (like we did for CodeMirror). The puzzle piece icon is already associated with templates since VE uses the same. We should incorporate the puzzle piece icon in the beta feature SVG, if we can.
We'll hear from community if they are having problems discovering the right icon.

Description: TemplateWizard allows you to add templates to wiki pages quickly and easily from WikiEditor. It makes use of TemplateData to show template and parameter descriptions for templates. It also allows for searching for wiki pages and commons images for template input from the editor itself.
Information page: https://www.mediawiki.org/wiki/Help:Extension:TemplateWizard
Discussion page: https://www.mediawiki.org/wiki/Help_talk:Extension:TemplateWizard

Acceptance criteria:
  • TemplateWizard is enable-able using a beta feature
Mockups:

TBD: SVG for beta feature

Does this need QA?

Yes

Event Timeline

Niharika triaged this task as Normal priority.Sep 24 2018, 2:48 PM
Niharika created this task.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptSep 24 2018, 2:48 PM
Niharika assigned this task to Prtksxna.EditedSep 24 2018, 2:51 PM
Niharika added a subscriber: Prtksxna.

@Prtksxna Assigning this to you for the SVG bit. You can un-claim the ticket once it's done. We should try to incorporate the puzzle piece icon in the SVG, if possible. We can talk more on this over chat/call.
Also take a look at the wording for description. Feel free to tweak.

Niharika updated the task description. (Show Details)Sep 24 2018, 3:01 PM

Is something like this ok? Will create RTL and SVG files if you're happy with it.

Niharika added a comment.EditedOct 2 2018, 3:12 PM

Is something like this ok? Will create RTL and SVG files if you're happy with it.

It'd be awesome if we can highlight that the icon lives in the editor toolbar. The puzzle piece icon size can be reduced - that should be fine. We can also show a popup depicting the editor dialog beneath it. What do you think?

You should play around with the feature to get a sense of it, if you haven't had a chance to yet. If you go to this page in the standard editor you should see a puzzle piece icon which activates the templatewizard.

Niharika set the point value for this task to 3.Oct 2 2018, 11:22 PM
Niharika moved this task from To be estimated/discussed to Estimated on the Community-Tech board.

Change 464090 had a related patch set uploaded (by Samwilson; owner: Samwilson):
[mediawiki/extensions/TemplateWizard@master] Add BetaFeatures support

https://gerrit.wikimedia.org/r/464090

Samwilson added a subscriber: Samwilson.

I've started the patch for this, but obviously the images in it need to be updated whenever they're available.

Do we add PNG and SVG versions (of the RTL and LTR screenshots)? Or just PNG?

I've started the patch for this, but obviously the images in it need to be updated whenever they're available.
Do we add PNG and SVG versions (of the RTL and LTR screenshots)? Or just PNG?

What do other extensions do? 🤔

And good point - @Prtksxna we would need an RTL version too. Nothing changes except for the background (wikipedia logo circle and sidebar move to the right). The puzzle piece icon is not flipped.

I've started the patch for this, but obviously the images in it need to be updated whenever they're available.
Do we add PNG and SVG versions (of the RTL and LTR screenshots)? Or just PNG?

What do other extensions do? 🤔

Structured Discussions has only SVG - https://github.com/wikimedia/mediawiki-extensions-Flow/tree/master/images

And good point - @Prtksxna we would need an RTL version too. Nothing changes except for the background (wikipedia logo circle and sidebar move to the right). The puzzle piece icon is not flipped.

Yep, as I mentioned previously, I'll make the RTL version once we're happy with the design.

It'd be awesome if we can highlight that the icon lives in the editor toolbar. The puzzle piece icon size can be reduced - that should be fine. We can also show a popup depicting the editor dialog beneath it. What do you think?

Is something like this better?

You should play around with the feature to get a sense of it, if you haven't had a chance to yet. If you go to this page in the standard editor you should see a puzzle piece icon which activates the templatewizard.

Thanks, this was helpful!

It'd be awesome if we can highlight that the icon lives in the editor toolbar. The puzzle piece icon size can be reduced - that should be fine. We can also show a popup depicting the editor dialog beneath it. What do you think?

Is something like this better?

That looks fine to me. Let's get the SVG versions for this and move forward on this.

LTRRTL
SVG
PNG
Source

I am not sure if it is my screen or something else, but I am seeing a slight difference in the blue in the RTL and LTR versions. Do you see it too? Actually, I see it for all RTL versions for betafeatures icons. We can start using them (since we never seem them together anywhere), but I'll investigate what is going on here.

Yeah that's strange: they do look different, but from what I can see they've both got the same colour (#3366ccff).

I've added them to the patch. Looks good to me. Even if they are different, I don't think it matters too much.

When I use a color picker on the screen, it gives me #4775d1 for the LTR, and ##3366cc for the RTL one, so it seems to not just be an artifact of our eyes. It might be some weird way these two render, specifically, on Phab?

If the SVG is the exact same definition of color, we can upload that and then test the beta feature ltr/rtl and see if there's a significant difference there. It might be a fluke on how the PNGs were rendered in this specific case.

Ah, it seems there there is different nesting in the SVGs. The RTL version doesn't have the blue inside an element with 0.9 opacity, hence the change in colour.

I've rejigged the SVGs in the above patch (and also taken out some redundant fill-rule="nonzero"s, because that's the default). Looks the same now.

Is this ready to go?

Change 464090 merged by jenkins-bot:
[mediawiki/extensions/TemplateWizard@master] Add BetaFeatures support

https://gerrit.wikimedia.org/r/464090

Prtksxna reassigned this task from Prtksxna to Samwilson.Oct 16 2018, 5:13 AM
MaxSem added a subscriber: MaxSem.Oct 17 2018, 10:13 PM

The above mentioned patch is merged - anything else left?

Needs a mild QA review once it's out on all projects.

It looks like the new Beta Feature code is on Test Wikipedia now, but TemplateWizard isn't showing up in the Beta Features there. It probably needs to be added to that weird Beta Features whitelist in the configs.

Change 468483 had a related patch set uploaded (by Kaldari; owner: Kaldari):
[operations/mediawiki-config@master] Adding TemplateWizard to Beta Features whitelist

https://gerrit.wikimedia.org/r/468483

kaldari added subscribers: Jdforrester-WMF, greg.EditedOct 18 2018, 10:41 PM

FWIW, the config documentation says that we need to get either @greg or @Jdforrester-WMF to approve adding this to the whitelist. I've added both of them as reviewers for the config change patch. Greg suggested we add TemplateWizard to https://www.mediawiki.org/wiki/Beta_Features/New_Features, although no one has used that page for last two years. My suggestion is to ping James when he gets back from the RI offsite on Monday and see if he'll just +1 the config change, and then schedule it for a SWAT deployment next week. (Note that I will be on vacation that week.)

Hey, looks fine, though "Help:Extension:TemplateWizard" and "Help talk:Extension:TemplateWizard" are a tad ugly as titles. :-) +1ed.

Change 468483 merged by jenkins-bot:
[operations/mediawiki-config@master] Adding TemplateWizard to Beta Features whitelist

https://gerrit.wikimedia.org/r/468483

Mentioned in SAL (#wikimedia-operations) [2018-10-22T18:31:37Z] <jforrester@deploy1001> Synchronized wmf-config/InitialiseSettings.php: SWAT Add TemplateWizard to the BF allow list T205290 (duration: 00m 48s)

Niharika closed this task as Resolved.Oct 31 2018, 7:08 PM
Niharika moved this task from QA to Q2 2018-19 on the Community-Tech-Sprint board.